'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var babelPluginJsxDomExpressions = require('babel-plugin-jsx-dom-expressions');

var Core, comparer;

comparer = function(v, k, b, is_array, path, r) {
  var new_path, ref, ref1;
  new_path = path.concat([k]);
  if (is_array && !(((v != null ? v.id : void 0) && (v != null ? v.id : void 0) === ((ref = b[k]) != null ? ref.id : void 0)) || ((v != null ? v._id : void 0) && (v != null ? v._id : void 0) === ((ref1 = b[k]) != null ? ref1._id : void 0))) || !((v != null) && ((b != null ? b[k] : void 0) != null) && (v instanceof Object))) {
    return r.push(new_path.concat([v]));
  }
  return r.push.apply(r, Core.diff(v, b[k], new_path));
};

var Core$1 = Core = {
  context: null,
  queues: {
    immediate: {
      tasks: [],
      nextIndex: 0,
      nextHandle: 1
    },
    deferred: {
      tasks: [],
      nextIndex: 0,
      nextHandle: 1
    }
  },
  clock: 0,
  queueTask: function(task, defer) {
    var q;
    if (defer) {
      q = Core.queues.deferred;
      if (!q.tasks.length) {
        Promise.resolve().then(function() {
          Core.processUpdates(q);
          return Core.clock++;
        });
      }
      q.tasks.push(task);
      return q.nextHandle++;
    }
    Core.queues.immediate.tasks.push(task);
    return Core.queues.immediate.nextHandle++;
  },
  cancelTask: function(handle, defer) {
    var index, q;
    q = defer ? Core.queues.deferred : Core.queues.immediate;
    index = handle - (q.nextHandle - q.tasks.length);
    if (q.nextIndex <= index) {
      return q.tasks[index] = null;
    }
  },
  processUpdates: function(q) {
    var count, err, mark, task;
    count = 0;
    mark = 0;
    while (q.nextIndex < q.tasks.length) {
      if (!(task = q.tasks[q.nextIndex])) {
        q.nextIndex++;
        continue;
      }
      if (q.nextIndex > mark) {
        if (count++ > 5000) {
          console.error('Exceeded max task recursion');
          q.nextIndex = 0;
          return q.tasks = [];
        }
        mark = q.tasks.length;
      }
      try {
        task(task.value);
        task.handle = null;
        task.value = null;
      } catch (error) {
        err = error;
        console.error(err);
      }
      q.nextIndex++;
    }
    q.nextIndex = 0;
    q.tasks = [];
  },
  run: function(fn) {
    var execute;
    execute = !Core.queues.immediate.tasks.length;
    fn();
    if (execute) {
      return Core.processUpdates(Core.queues.immediate);
    }
  },
  setContext: function(newContext, fn) {
    var context, ret;
    context = Core.context;
    Core.context = newContext;
    ret = fn();
    Core.context = context;
    return ret;
  },
  root: function(fn) {
    var d;
    return Core.setContext({
      disposables: d = []
    }, function() {
      return fn(function() {
        var disposable, i, len;
        for (i = 0, len = d.length; i < len; i++) {
          disposable = d[i];
          disposable();
        }
        d = [];
      });
    });
  },
  ignore: function(fn) {
    var disposables;
    ({disposables} = Core.context || {});
    return Core.setContext({disposables}, fn);
  },
  isObject: function(obj) {
    var ref;
    return obj !== null && ((ref = typeof obj) === 'object' || ref === 'function');
  },
  isFunction: function(val) {
    return typeof val === 'function';
  },
  diff: function(a, b, path = []) {
    var i, k, l, len, r, v;
    r = [];
    if (!Core.isObject(a) || (b == null)) {
      if (a !== b) {
        r.push(path.concat([a]));
      }
    } else if (Array.isArray(a)) {
      for (k = i = 0, len = a.length; i < len; k = ++i) {
        v = a[k];
        if ((b != null ? b[k] : void 0) !== v) {
          comparer(v, k, b, true, path, r);
        }
      }
      if ((b != null ? b.length : void 0) > a.length) {
        l = a.length;
        while (l < b.length) {
          r.push(path.concat([l, void 0]));
          l++;
        }
      }
    } else {
      for (k in a) {
        v = a[k];
        if ((b != null ? b[k] : void 0) !== v) {
          comparer(v, k, b, false, path, r);
        }
      }
      for (k in b) {
        v = b[k];
        if (!(k in a)) {
          r.push(path.concat([k, void 0]));
        }
      }
    }
    return r;
  },
  clone: function(v) {
    var k, obj;
    if (!Core.isObject(v)) {
      return v;
    }
    if (Array.isArray(v)) {
      return v.slice(0);
    }
    obj = {};
    for (k in v) {
      obj[k] = v[k];
    }
    return obj;
  },
  unwrap: function(item, deep) {
    var k, result, unwrapped, v;
    if (result = item != null ? item._state : void 0) {
      return result;
    }
    if (!(deep && Core.isObject(item) && !Core.isFunction(item) && !(item instanceof Element) && !(item instanceof DocumentFragment))) {
      return item;
    }
    for (k in item) {
      v = item[k];
      if ((unwrapped = Core.unwrap(v, true)) !== v) {
        item[k] = unwrapped;
      }
    }
    return item;
  }
};

function symbolObservablePonyfill(root) {
	var result;
	var Symbol = root.Symbol;

	if (typeof Symbol === 'function') {
		if (Symbol.observable) {
			result = Symbol.observable;
		} else {
			result = Symbol('observable');
			Symbol.observable = result;
		}
	} else {
		result = '@@observable';
	}

	return result;
}

/* global window */

var root;

if (typeof self !== 'undefined') {
  root = self;
} else if (typeof window !== 'undefined') {
  root = window;
} else if (typeof global !== 'undefined') {
  root = global;
} else if (typeof module !== 'undefined') {
  root = module;
} else {
  root = Function('return this')();
}

var result = symbolObservablePonyfill(root);

var Sync;

var Sync$1 = Sync = class Sync {
  constructor(handler, {defer = true} = {}) {
    var ref;
    this.handler = handler;
    this.execute = this.execute.bind(this);
    this.execute.defer = defer;
    this.context = {
      fn: this.execute,
      disposables: []
    };
    this.execute();
    if ((ref = Core$1.context) != null) {
      ref.disposables.push(this.dispose.bind(this));
    }
  }

  execute() {
    if (this.__disposed) {
      return;
    }
    this.clean();
    return Core$1.setContext(this.context, this.handler);
  }

  clean() {
    var disposable, i, len, ref;
    ref = this.context.disposables;
    for (i = 0, len = ref.length; i < len; i++) {
      disposable = ref[i];
      disposable();
    }
    return this.context.disposables = [];
  }

  dispose() {
    if (this.__disposed) {
      return;
    }
    this.clean();
    return this.__disposed = true;
  }

};

var Signal, counter;

counter = 0;

var Signal$1 = Signal = class Signal {
  constructor(value) {
    this.sid = 's_' + counter++;
    this.__subscriptions = new Set();
    this.__value = value;
    Object.defineProperty(this, 'value', {
      get: function() {
        var ref;
        if ((ref = Core$1.context) != null ? ref.fn : void 0) {
          Core$1.context.disposables.push(this._subscribe(Core$1.context.fn).unsubscribe);
        }
        return this.__value;
      },
      configurable: true
    });
    Object.defineProperty(this, result, {
      value: function() {
        return this;
      }
    });
  }

  peek() {
    return this.__value;
  }

  next(value, notify = true) {
    this.__value = value;
    if (notify) {
      return this.notify('next', value);
    }
  }

  subscribe(observer) {
    var d;
    d = this._subscribe(arguments);
    (observer.next || observer)(this.__value);
    return d;
  }

  _subscribe(observer) {
    if (typeof observer !== 'object' || observer === null) {
      observer = {
        next: observer,
        error: arguments[1],
        complete: arguments[2]
      };
    }
    this.__subscriptions.add(observer);
    return {
      unsubscribe: this.unsubscribe.bind(this, observer)
    };
  }

  unsubscribe(observer) {
    return this.__subscriptions.delete(observer);
  }

  notify(type, value) {
    if (!this.__subscriptions.size) {
      return;
    }
    return Core$1.run(() => {
      var handler, ref, sub;
      ref = this.__subscriptions;
      for (sub of ref) {
        if (!(handler = sub[type])) {
          continue;
        }
        if (handler.handle != null) {
          Core$1.cancelTask(sub.handle, sub.defer);
        }
        handler.value = value;
        handler.handle = Core$1.queueTask(handler, handler.defer);
      }
    });
  }

};

var Selector, sequenceCounter;

sequenceCounter = 0;

var Selector$1 = Selector = class Selector extends Signal$1 {
  constructor(handler, {defer} = {}) {
    var ref;
    super();
    this.handler = handler;
    Object.defineProperty(this, 'value', {
      get: function() {
        var ref;
        if ((ref = Core$1.context) != null ? ref.fn : void 0) {
          Core$1.context.disposables.push(this._subscribe(Core$1.context.fn).unsubscribe);
        }
        if (!this.context.disposables.length) {
          this.execute();
        }
        return this.__value;
      },
      enumerable: true
    });
    this.execute = this.execute.bind(this);
    this.execute.defer = defer;
    this.context = {
      fn: this.execute,
      disposables: [],
      pure: true
    };
    if ((ref = Core$1.context) != null) {
      ref.disposables.push(this.dispose.bind(this));
    }
  }

  execute() {
    var context, currentSeq, is_sleeping, new_val, sub;
    if (this.__disposed) {
      return;
    }
    this.seq = currentSeq = sequenceCounter++;
    this.clean();
    is_sleeping = !this.__subscriptions.size;
    context = is_sleeping ? null : this.context;
    new_val = Core$1.setContext(context, () => {
      return this.handler(this.__value);
    });
    if (new_val && Core$1.isObject(new_val)) {
      if ('then' in new_val) {
        new_val.then((new_val) => {
          if (this.__disposed || this.seq !== currentSeq) {
            return;
          }
          return this.resolve(new_val);
        }).catch((err) => {
          return this.notify('error', err);
        });
        return;
      }
      if (result in new_val) {
        this.context.disposables.push((sub = new_val[result]().subscribe((val) => {
          return this.resolve(val);
        }, (err) => {
          return this.notify('error', err);
        })).unsubscribe.bind(sub));
        return;
      }
    }
    return this.resolve(new_val);
  }

  resolve(new_val) {
    new_val = Core$1.unwrap(new_val, true);
    if (new_val === this.__value && !Core$1.isObject(new_val)) {
      return;
    }
    return super.next(new_val, !this._skipNotify);
  }

  next() {}

  peek() {
    if (!this.context.disposables.length) {
      this.execute();
    }
    return super.peek();
  }

  subscribe(observer) {
    var d, oldSize;
    oldSize = this.__subscriptions.size;
    d = this._subscribe(arguments);
    if (!oldSize) {
      return d;
    }
    (observer.next || observer)(this.__value);
    return d;
  }

  _subscribe(fn) {
    var disposable, oldSize;
    oldSize = this.__subscriptions.size;
    disposable = super._subscribe(fn);
    if (!oldSize && this.__subscriptions.size && !this.context.disposables.length) {
      this._skipNotify = true;
      this.execute();
      delete this._skipNotify;
    }
    return disposable;
  }

  unsubscribe(fn) {
    super.unsubscribe(fn);
    return Core$1.queueTask(() => {
      if (!this.__subscriptions.size) {
        return this.clean();
      }
    }, true);
  }

  clean() {
    var disposable, i, len, ref;
    ref = this.context.disposables;
    for (i = 0, len = ref.length; i < len; i++) {
      disposable = ref[i];
      disposable();
    }
    return this.context.disposables = [];
  }

  dispose() {
    if (this.__disposed) {
      return;
    }
    this.notify('complete');
    this.clean();
    return this.__disposed = true;
  }

};

Signal$1.prototype.map = function(fn) {
  return new Selector(() => {
    return fn(this.value);
  });
};

var mapSelector, runtime;

runtime = babelPluginJsxDomExpressions.createRuntime({
  wrapExpr: function(accessor, fn) {
    return new Sync$1(function() {
      var sub, value;
      value = accessor();
      if (Core$1.isObject(value)) {
        if ('sid' in value) {
          new Sync$1(function() {
            return fn(value.value);
          });
          return;
        }
        if ('then' in value) {
          value.then(fn);
          return;
        }
        if (result in value) {
          Core$1.context.disposables.push((sub = value[result]().subscribe(fn)).unsubscribe.bind(sub));
          return;
        }
      }
      return fn(value);
    });
  },
  sanitize: Core$1.unwrap
});

mapSelector = function(valueAccessor, mapFn) {
  var disposables, length, list, mapped;
  mapped = [];
  list = [];
  disposables = [];
  length = 0;
  Core$1.context.disposables.push(function() {
    var d, k, len;
    for (k = 0, len = disposables.length; k < len; k++) {
      d = disposables[k];
      d();
    }
    return disposables = [];
  });
  return new Selector$1(function() {
    var d, end, i, indexedItems, item, itemIndex, j, k, l, len, len1, len2, m, newEnd, newLength, newList, newListUnwrapped, newMapped, start, tempDisposables;
    newList = valueAccessor();
    // non-arrays
    newListUnwrapped = (newList != null ? newList._state : void 0) || newList;
    if (!Array.isArray(newListUnwrapped)) {
      if ((newListUnwrapped == null) || newListUnwrapped === false) {
        mapped = [];
        list = [];
        for (k = 0, len = disposables.length; k < len; k++) {
          d = disposables[k];
          d();
        }
        disposables = [];
        return;
      }
      if (list[0] === newListUnwrapped) {
        return mapped[0];
      }
      for (l = 0, len1 = disposables.length; l < len1; l++) {
        d = disposables[l];
        d();
      }
      disposables = [];
      list[0] = newListUnwrapped;
      return mapped[0] = Core$1.root(function(dispose) {
        disposables[0] = dispose;
        return mapFn(newList);
      });
    }
    newLength = newListUnwrapped.length;
    if (newLength === 0) {
      if (length !== 0) {
        list = [];
        mapped = [];
        length = 0;
        for (m = 0, len2 = disposables.length; m < len2; m++) {
          d = disposables[m];
          d();
        }
        disposables = [];
      }
    } else if (length === 0) {
      i = 0;
      while (i < newLength) {
        list[i] = newListUnwrapped[i];
        mapped[i] = Core$1.root(function(dispose) {
          disposables[i] = dispose;
          return mapFn((typeof newList.peek === "function" ? newList.peek(i) : void 0) || newList[i], i);
        });
        i++;
      }
      length = newLength;
    } else {
      newMapped = new Array(newLength);
      tempDisposables = new Array(newLength);
      indexedItems = new Map();
      end = Math.min(length, newLength);
      // reduce from both ends
      start = 0;
      while (start < end && newListUnwrapped[start] === list[start]) {
        start++;
      }
      end = length - 1;
      newEnd = newLength - 1;
      while (end >= 0 && newEnd >= 0 && newListUnwrapped[newEnd] === list[end]) {
        newMapped[newEnd] = mapped[end];
        tempDisposables[newEnd] = disposables[newEnd];
        end--;
        newEnd--;
      }
      // create indices
      j = newEnd;
      while (j >= start) {
        item = newListUnwrapped[j];
        itemIndex = indexedItems.get(item);
        if (itemIndex != null) {
          itemIndex.push(j);
        } else {
          indexedItems.set(item, [j]);
        }
        j--;
      }
      // find old items
      i = start;
      while (i <= end) {
        item = list[i];
        itemIndex = indexedItems.get(item);
        if ((itemIndex != null) && itemIndex.length > 0) {
          j = itemIndex.pop();
          newMapped[j] = mapped[i];
          tempDisposables[j] = disposables[i];
        } else {
          disposables[i]();
        }
        i++;
      }
      // set all new values
      j = start;
      while (j < newLength) {
        if (newMapped.hasOwnProperty(j)) {
          mapped[j] = newMapped[j];
          disposables[i] = tempDisposables[i];
        } else {
          mapped[j] = Core$1.root(function(dispose) {
            disposables[j] = dispose;
            return mapFn((typeof newList.peek === "function" ? newList.peek(j) : void 0) || newList[j], j);
          });
        }
        j++;
      }
      // truncate extra length
      length = mapped.length = disposables.length = newLength;
      // save list for next iteration
      list = newListUnwrapped.slice(0);
    }
    return mapped;
  });
};

runtime.map = mapSelector;

var Renderer = runtime;

var DEFINED, Handler;

DEFINED = {
  '_state': true,
  'on': true,
  'peek': true
};

var Handler$1 = Handler = class Handler {
  constructor(_state) {
    var i, len, method, ref;
    this._state = _state;
    this.__subscriptions = new Set();
    this._child_subscriptions = {};
    ref = Object.keys(DEFINED).slice(2);
    for (i = 0, len = ref.length; i < len; i++) {
      method = ref[i];
      this[method] = this[method].bind(this);
    }
  }

  get(target, property) {
    var ref, value;
    if (DEFINED[property]) {
      return this[property];
    }
    if (!((ref = Core$1.context) != null ? ref.fn : void 0) || property === 'length' || typeof property === 'symbol') {
      return target[property];
    }
    if ((value = target[property]) != null) {
      if (Core$1.isFunction(value)) {
        return value;
      }
      if (Core$1.isObject(value) && Object.isFrozen(value)) {
        value = Core$1.clone(value);
        target[property] = value;
      }
      value = Handler.wrap(value);
    }
    Core$1.context.disposables.push(this.on(property, Core$1.context.fn).unsubscribe);
    return value;
  }

  set(target, property, value) {
    return true;
  }

  deleteProperty(target, property) {
    return true;
  }

  subscribe(fn) {
    this.__subscriptions.add(fn);
    return {
      unsubscribe: () => {
        return this.__subscriptions.delete(fn);
      }
    };
  }

  notify(value) {
    if (!this.__subscriptions.size) {
      return;
    }
    return Core$1.run(() => {
      var ref, sub;
      ref = this.__subscriptions;
      for (sub of ref) {
        if (sub.handle != null) {
          Core$1.cancelTask(sub.handle, sub.defer);
        }
        sub.value = value;
        sub.handle = Core$1.queueTask(sub, sub.defer);
      }
    });
  }

};

Handler.wrappers = new WeakMap();

Handler.wrap = function(value) {
  var handler, proxy, wrapper;
  if (!(Core$1.isObject(value) && !(value instanceof Element))) {
    return value;
  }
  if (!(wrapper = Handler.wrappers.get(value))) {
    proxy = new Proxy(value, handler = new Handler(value));
    Handler.wrappers.set(value, {proxy, handler});
  } else {
    ({proxy} = wrapper);
  }
  return proxy;
};

Handler.handler = function(value) {
  var handler, proxy, wrapper;
  if (!(Core$1.isObject(value) && !(value instanceof Element))) {
    return value;
  }
  if (!(wrapper = Handler.wrappers.get(value))) {
    proxy = new Proxy(value, handler = new Handler(value));
    Handler.wrappers.set(value, {proxy, handler});
  } else {
    ({handler} = wrapper);
  }
  return handler;
};

var methods;

methods = {
  trigger: function(property, value, notify) {
    var subs;
    subs = this._child_subscriptions[property];
    if (subs != null ? subs.size : void 0) {
      Core$1.run(function() {
        var sub;
        for (sub of subs) {
          if (sub.handle != null) {
            Core$1.cancelTask(sub.handle, sub.defer);
          }
          sub.value = value;
          sub.handle = Core$1.queueTask(sub, sub.defer);
        }
      });
    }
    if (notify) {
      return this.notify(this._state);
    }
  },
  peek: function(property) {
    var value;
    value = this._state[property];
    if (Core$1.isObject(value) && Object.isFrozen(value)) {
      value = Core$1.clone(value);
      this._state[property] = value;
    }
    return Handler$1.wrap(value);
  },
  on: function(property, fn) {
    var base, disposable, handler, value;
    value = this._state[property];
    disposable = null;
    if (Core$1.isObject(value) && !(Core$1.isFunction(value) || value instanceof Element)) {
      handler = Handler$1.handler(value);
      disposable = handler.subscribe(fn);
    }
    (base = this._child_subscriptions)[property] || (base[property] = new Set());
    this._child_subscriptions[property].add(fn);
    return {
      unsubscribe: () => {
        if (disposable) {
          disposable.unsubscribe();
        }
        return this._child_subscriptions[property].delete(fn);
      }
    };
  }
};

Object.assign(Handler$1.prototype, methods);

var methods$1 = methods;

var State, setNested;

setNested = function(item, changes) {
  var handler, isArray, notify, property, value;
  handler = Handler$1.handler(item);
  isArray = Array.isArray(item);
  if (arguments.length === 3) {
    notify = isArray || !(arguments[1] in item);
    if (arguments[2] === void 0) {
      delete item[arguments[1]];
      if (isArray) {
        item.length--;
      }
    } else {
      item[arguments[1]] = arguments[2];
    }
    handler.trigger(arguments[1], arguments[2], notify);
    return;
  }
  for (property in changes) {
    value = changes[property];
    notify = isArray || !(property in item);
    if (value === void 0) {
      delete item[property];
    } else {
      item[property] = value;
    }
    handler.trigger(property, value, notify);
  }
};

var index = State = class State {
  constructor(state) {
    var k, ref;
    Object.defineProperties(this, {
      _state: {
        value: state,
        writable: true
      },
      _disposables: {
        value: [],
        writable: true
      },
      _child_subscriptions: {
        value: {},
        writable: true
      }
    });
    for (k in this._state) {
      this._defineProperty(k);
    }
    if ((ref = Core$1.context) != null) {
      ref.disposables.push(this.dispose.bind(this));
    }
  }

  set() {
    var changes, current, i, property, ref, ref1, temp, value;
    if ((ref = Core$1.context) != null ? ref.pure : void 0) {
      return console.log('Cannot update in a Selector');
    }
    if (arguments.length === 1) {
      ref1 = arguments[0];
      for (property in ref1) {
        value = ref1[property];
        this._setProperty(property, value);
      }
      return;
    }
    current = this._state;
    changes = arguments[arguments.length - 1];
    i = 0;
    while (i < arguments.length - 1 && ((temp = current[arguments[i]]) != null)) {
      current = temp;
      i++;
    }
    setNested(current, changes);
  }

  replace() {
    var change, current, i, j, len, property, ref, temp, value;
    if (arguments.length === 1) {
      if (!(arguments[0] instanceof Object)) {
        return console.log('replace must be provided a replacement state');
      }
      ref = Core$1.diff(arguments[0], this._state);
      for (j = 0, len = ref.length; j < len; j++) {
        change = ref[j];
        this.replace(change);
      }
      return;
    }
    if (arguments.length === 2) {
      this._setProperty(arguments[0], arguments[1]);
      return;
    }
    current = this._state;
    value = arguments[arguments.length - 1];
    property = arguments[arguments.length - 2];
    i = 0;
    while (i < arguments.length - 2 && ((temp = current[arguments[i]]) != null)) {
      current = temp;
      i++;
    }
    setNested(current, property, value);
  }

  select() {
    var j, key, len, selection, selector;
    for (j = 0, len = arguments.length; j < len; j++) {
      selection = arguments[j];
      if (Core$1.isFunction(selection) || 'subscribe' in selection) {
        selector = Core$1.isFunction(selection) ? new Selector$1(selection) : selection;
        this._disposables.push(selector.subscribe((value) => {
          var change, key, l, len1, ref, val;
          ref = [].concat(...((function() {
            var ref, results;
            ref = value || {};
            results = [];
            for (key in ref) {
              val = ref[key];
              results.push(Core$1.diff(val, this._state[key], [key]));
            }
            return results;
          }).call(this)));
          for (l = 0, len1 = ref.length; l < len1; l++) {
            change = ref[l];
            this.replace(...change);
          }
        }));
        continue;
      }
      if ('then' in selection) {
        selection.then((value) => {
          var change, key, l, len1, ref, val;
          ref = [].concat(...((function() {
            var ref, results;
            ref = value || {};
            results = [];
            for (key in ref) {
              val = ref[key];
              results.push(Core$1.diff(val, this._state[key], [key]));
            }
            return results;
          }).call(this)));
          for (l = 0, len1 = ref.length; l < len1; l++) {
            change = ref[l];
            this.replace(...change);
          }
        });
        continue;
      }
      for (key in selection) {
        selector = selection[key];
        ((key, selector) => {
          if (!(key in this)) {
            this._defineProperty(key);
          }
          selector = Core$1.isFunction(selector) ? new Selector$1(selector) : selector;
          if ('then' in selector) {
            return selector.then((value) => {
              var change, l, len1, ref;
              ref = Core$1.diff(value, this._state[key], [key]);
              for (l = 0, len1 = ref.length; l < len1; l++) {
                change = ref[l];
                this.replace(...change);
              }
            });
          }
          return this._disposables.push(selector.subscribe((value) => {
            var change, l, len1, ref;
            ref = Core$1.diff(value, this._state[key], [key]);
            for (l = 0, len1 = ref.length; l < len1; l++) {
              change = ref[l];
              this.replace(...change);
            }
          }));
        })(key, selector);
      }
    }
  }

  dispose() {
    var disposable, j, len, ref;
    if (!this._disposables) {
      return;
    }
    ref = this._disposables;
    for (j = 0, len = ref.length; j < len; j++) {
      disposable = ref[j];
      disposable.unsubscribe();
    }
    this._disposables = null;
  }

  _setProperty(property, value) {
    if (!(property in this)) {
      this._defineProperty(property);
    }
    if (value === void 0) {
      delete this._state[property];
    } else {
      this._state[property] = value;
    }
    return this.trigger(property, value);
  }

  _defineProperty(property) {
    return Object.defineProperty(this, property, {
      get: () => {
        var ref, value;
        if (!((ref = Core$1.context) != null ? ref.fn : void 0)) {
          return this._state[property];
        }
        if ((value = this._state[property]) != null) {
          if (Core$1.isFunction(value)) {
            return value;
          }
          if (Core$1.isObject(value) && Object.isFrozen(value)) {
            value = Core$1.clone(value);
            this._state[property] = value;
          }
          value = Handler$1.wrap(value);
        }
        Core$1.context.disposables.push(this.on(property, Core$1.context.fn).unsubscribe);
        return value;
      },
      enumerable: true
    });
  }

};

Object.assign(State.prototype, methods$1);

var DEFINED$1, ImmutableHandler;

DEFINED$1 = {
  '_state': true,
  'on': true,
  'peek': true,
  'map': true
};

var ImmutableHandler$1 = ImmutableHandler = class ImmutableHandler {
  constructor(target, _state, root) {
    this._state = _state;
    this.root = root;
    this.peek = this.peek.bind(this, target);
    this.on = this.on.bind(this, target);
    if (Array.isArray(this._state)) {
      this.map = this.map.bind(this, target);
    }
    this.stateClock = target.clock || Core$1.clock;
  }

  get(target, property) {
    var base, base1, ref, value;
    if (this.stateClock < target.clock) {
      this.resolveState(target);
    }
    if (property === 'length' || typeof property === 'symbol') {
      return this._state[property];
    }
    if (property.endsWith('$')) {
      property = property.slice(0, -1);
      if (Core$1.context.fn) {
        target[property] || (target[property] = {
          _subs: new Set(),
          clock: Core$1.clock
        });
        (base = target[property])._subPath || (base._subPath = new Set());
        target[property]._subPath.add(Core$1.context.fn);
        Core$1.context.disposables.push(target[property]._subPath.delete(Core$1.context.fn));
      }
      return this._state[property];
    }
    if (DEFINED$1[property]) {
      return this[property];
    }
    if (!((ref = Core$1.context) != null ? ref.fn : void 0)) {
      return this._state[property];
    }
    if (((value = this._state[property]) != null) && Core$1.isObject(value) && !(value instanceof Element)) {
      if (Core$1.isFunction(value)) {
        return value;
      }
      target[property] || (target[property] = {
        clock: Core$1.clock
      });
      (base1 = target[property]).path || (base1.path = target.path.concat([property]));
      value = new Proxy(target[property], new ImmutableHandler(target[property], value, this.root));
    }
    Core$1.context.disposables.push(this.on(property, Core$1.context.fn).unsubscribe);
    return value;
  }

  set(target, property, value) {
    return true;
  }

  deleteProperty(target, property) {
    return true;
  }

  on(target, property, fn) {
    var base;
    target[property] || (target[property] = {
      clock: Core$1.clock
    });
    (base = target[property])._subs || (base._subs = new Set());
    target[property]._subs.add(fn);
    return {
      unsubscribe: function() {
        return target[property]._subs.delete(fn);
      }
    };
  }

  peek(target, property) {
    var base, value;
    if (this.stateClock < target.clock) {
      this.resolveState(target);
    }
    value = this._state[property];
    if ((value == null) || Core$1.isFunction(value) || !Core$1.isObject(value) || (value instanceof Element)) {
      return value;
    }
    target[property] || (target[property] = {});
    (base = target[property]).path || (base.path = target.path.concat([property]));
    return new Proxy(target[property], new ImmutableHandler(target[property], value, this.root));
  }

  map(target, fn) {
    if (this.stateClock < target.clock) {
      this.resolveState(target);
    }
    return this._state.map((value, i, a) => {
      var base;
      if (!((value == null) || Core$1.isFunction(value) || !Core$1.isObject(value) || (value instanceof Element))) {
        target[i] || (target[i] = {});
        (base = target[i]).path || (base.path = target.path.concat([i]));
        value = new Proxy(target[i], new ImmutableHandler(target[i], value, this.root));
      }
      return fn(value, i, a);
    });
  }

  resolveState(target) {
    var current, i, l;
    current = this.root._state;
    i = 0;
    l = target.path.length;
    while (i < l) {
      if (current) {
        current = current[target.path[i]];
      }
      i++;
    }
    this._state = current;
    return this.stateClock = Core$1.clock;
  }

};

var ImmutableState,
  indexOf = [].indexOf;

var index$1 = ImmutableState = class ImmutableState {
  constructor(state) {
    var k, ref;
    Object.defineProperties(this, {
      _state: {
        value: state,
        writable: true
      },
      _disposables: {
        value: [],
        writable: true
      },
      _subscriptions: {
        value: {},
        writable: true
      }
    });
    for (k in this._state) {
      this._defineProperty(k);
    }
    if ((ref = Core$1.context) != null) {
      ref.disposables.push(this.dispose.bind(this));
    }
  }

  set() {
    var changes, j, k, len, notify, path, property, ref, ref1, ref2, state, subKeys, subPaths, subs, value;
    if ((ref = Core$1.context) != null ? ref.pure : void 0) {
      return console.log('Cannot update in a Selector');
    }
    if (arguments.length === 1) {
      ref1 = arguments[0];
      for (property in ref1) {
        value = ref1[property];
        this._setProperty(property, value);
      }
      return;
    }
    changes = arguments[arguments.length - 1];
    ({state, subs, subPaths} = this._resolvePath(arguments, arguments.length - 1));
    if (!state) {
      return;
    }
    notify = Array.isArray(state);
    for (property in changes) {
      value = changes[property];
      notify = notify || !(indexOf.call(state, property) >= 0);
      if (value === void 0) {
        delete state[property];
      } else {
        state[property] = value;
      }
      if (subs) {
        this.trigger(subs != null ? (ref2 = subs[property]) != null ? ref2._subs : void 0 : void 0, value);
      }
    }
    if (notify) {
      this.trigger(subs != null ? subs._subs : void 0, state);
    }
    for (j = 0, len = subPaths.length; j < len; j++) {
      path = subPaths[j];
      this.trigger(path.subs, path.state);
    }
    // prune subs
    if (value === void 0) {
      delete subs[property];
    } else if (Array.isArray(value) && !value.length) {
      subKeys = ['_subs', 'clock', '_subPath'];
      for (k in subs[property]) {
        if (!(indexOf.call(subKeys, k) >= 0)) {
          delete subs[property][k];
        }
      }
    }
  }

  replace() {
    var change, j, l, len, len1, notify, path, property, ref, ref1, state, subPaths, subs, value;
    if (arguments.length === 1) {
      if (!(arguments[0] instanceof Object)) {
        return console.log('replace must be provided a replacement state');
      }
      ref = Core$1.diff(arguments[0], this._state);
      for (j = 0, len = ref.length; j < len; j++) {
        change = ref[j];
        this.replace(change);
      }
      return;
    }
    if (arguments.length === 2) {
      this._setProperty(arguments[0], arguments[1]);
      return;
    }
    value = arguments[arguments.length - 1];
    property = arguments[arguments.length - 2];
    ({state, subs, subPaths} = this._resolvePath(arguments, arguments.length - 2));
    if (!state) {
      return;
    }
    if (value === void 0 && Array.isArray(state)) {
      state.length -= 1;
      notify = true;
    } else {
      notify = Array.isArray(state) || !(indexOf.call(state, property) >= 0);
      if (value === void 0) {
        delete state[property];
      } else {
        state[property] = value;
      }
    }
    if (subs) {
      this.trigger((ref1 = subs[property]) != null ? ref1._subs : void 0, value);
    }
    if (notify) {
      this.trigger(subs._subs, state);
    }
    for (l = 0, len1 = subPaths.length; l < len1; l++) {
      path = subPaths[l];
      this.trigger(path.subs, path.state);
    }
  }

  select() {
    var j, key, len, selection, selector;
    for (j = 0, len = arguments.length; j < len; j++) {
      selection = arguments[j];
      if (Core$1.isFunction(selection) || 'subscribe' in selection) {
        selector = Core$1.isFunction(selection) ? new Selector$1(selection) : selection;
        this._disposables.push(selector.subscribe((value) => {
          var change, key, l, len1, ref, val;
          ref = [].concat(...((function() {
            var ref, results;
            ref = value || {};
            results = [];
            for (key in ref) {
              val = ref[key];
              results.push(Core$1.diff(val, this._state[key], [key]));
            }
            return results;
          }).call(this)));
          for (l = 0, len1 = ref.length; l < len1; l++) {
            change = ref[l];
            this.replace(...change);
          }
        }));
        continue;
      }
      if ('then' in selection) {
        selection.then((value) => {
          var change, key, l, len1, ref, val;
          ref = [].concat(...((function() {
            var ref, results;
            ref = value || {};
            results = [];
            for (key in ref) {
              val = ref[key];
              results.push(Core$1.diff(val, this._state[key], [key]));
            }
            return results;
          }).call(this)));
          for (l = 0, len1 = ref.length; l < len1; l++) {
            change = ref[l];
            this.replace(...change);
          }
        });
        continue;
      }
      for (key in selection) {
        selector = selection[key];
        ((key, selector) => {
          if (!(key in this)) {
            this._defineProperty(key);
          }
          selector = Core$1.isFunction(selector) ? new Selector$1(selector) : selector;
          if ('then' in selector) {
            return selector.then((value) => {
              var change, l, len1, ref;
              ref = Core$1.diff(value, this._state[key], [key]);
              for (l = 0, len1 = ref.length; l < len1; l++) {
                change = ref[l];
                this.replace(...change);
              }
            });
          }
          return this._disposables.push(selector.subscribe((value) => {
            var change, l, len1, ref;
            ref = Core$1.diff(value, this._state[key], [key]);
            for (l = 0, len1 = ref.length; l < len1; l++) {
              change = ref[l];
              this.replace(...change);
            }
          }));
        })(key, selector);
      }
    }
  }

  on(property, fn) {
    var base, base1;
    (base = this._subscriptions)[property] || (base[property] = {
      clock: Core$1.clock
    });
    (base1 = this._subscriptions[property])._subs || (base1._subs = new Set());
    this._subscriptions[property]._subs.add(fn);
    return {
      unsubscribe: () => {
        return this._subscriptions[property]._subs.delete(fn);
      }
    };
  }

  trigger(subs, value) {
    if (!(subs != null ? subs.size : void 0)) {
      return;
    }
    return Core$1.run(function() {
      var sub;
      for (sub of subs) {
        if (sub.handle != null) {
          Core$1.cancelTask(sub.handle, sub.defer);
        }
        sub.value = value;
        sub.handle = Core$1.queueTask(sub, sub.defer);
      }
    });
  }

  dispose() {
    var disposable, j, len, ref;
    if (!this._disposables) {
      return;
    }
    ref = this._disposables;
    for (j = 0, len = ref.length; j < len; j++) {
      disposable = ref[j];
      disposable.unsubscribe();
    }
    this._disposables = null;
  }

  _resolvePath(path, length) {
    var currentState, currentSubs, i, ref, subPaths;
    currentState = this._state;
    currentSubs = this._subscriptions;
    subPaths = [];
    i = 0;
    while (i < length) {
      if (!currentSubs[path[i]]) {
        currentSubs[path[i]] = {};
      }
      currentSubs = currentSubs[path[i]];
      if (currentState != null) {
        if (currentSubs.clock !== Core$1.clock) {
          currentState[path[i]] = Core$1.clone(currentState[path[i]]);
          currentSubs.clock = Core$1.clock;
        }
        currentState = currentState[path[i]];
      }
      if (currentSubs != null ? (ref = currentSubs._subPath) != null ? ref.size : void 0 : void 0) {
        subPaths.push({
          state: currentState,
          subs: currentSubs._subPath
        });
      }
      i++;
    }
    return {
      state: currentState,
      subs: currentSubs,
      subPaths
    };
  }

  _setProperty(property, value) {
    var k, ref, ref1, subKeys;
    if (!(property in this)) {
      this._defineProperty(property);
    }
    if (value === void 0) {
      delete this._state[property];
    } else {
      this._state[property] = value;
    }
    this.trigger((ref = this._subscriptions[property]) != null ? ref._subs : void 0, value);
    this.trigger((ref1 = this._subscriptions[property]) != null ? ref1._subPath : void 0, value);
    // prune subs
    if (value === void 0) {
      delete this._subscriptions[property];
    } else if (Array.isArray(value) && !value.length) {
      subKeys = ['_subs', 'clock', '_subPath'];
      for (k in this._subscriptions[property]) {
        if (!(indexOf.call(subKeys, k) >= 0)) {
          delete this._subscriptions[property][k];
        }
      }
    }
  }

  _defineProperty(property) {
    Object.defineProperty(this, property, {
      get: () => {
        var base, base1, ref, value;
        if (!((ref = Core$1.context) != null ? ref.fn : void 0)) {
          return this._state[property];
        }
        if (((value = this._state[property]) != null) && Core$1.isObject(value) && !(value instanceof Element)) {
          if (Core$1.isFunction(value)) {
            return value;
          }
          (base = this._subscriptions)[property] || (base[property] = {
            clock: Core$1.clock
          });
          (base1 = this._subscriptions[property]).path || (base1.path = [property]);
          value = new Proxy(this._subscriptions[property], new ImmutableHandler$1(this._subscriptions[property], value, this));
        }
        Core$1.context.disposables.push(this.on(property, Core$1.context.fn).unsubscribe);
        return value;
      },
      enumerable: true
    });
    return Object.defineProperty(this, property + '$', {
      get: () => {
        var base, base1, fn;
        if (fn = Core$1.context.fn) {
          (base = this._subscriptions)[property] || (base[property] = {
            _subs: new Set(),
            clock: Core$1.clock
          });
          (base1 = this._subscriptions[property])._subPath || (base1._subPath = new Set());
          this._subscriptions[property]._subPath.add(Core$1.context.fn);
          Core$1.context.disposables.push(() => {
            return this._subscriptions[property]._subPath.delete(fn);
          });
        }
        return this._state[property];
      }
    });
  }

};

var index$2 = Object.assign({
  ignore: Core$1.ignore,
  root: Core$1.root,
  unwrap: Core$1.unwrap
}, Renderer);

exports.default = index$2;
exports.State = index;
exports.ImmutableState = index$1;
exports.Signal = Signal$1;
exports.Selector = Selector$1;
exports.Sync = Sync$1;
